#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;

const int MAXN=100;


void getStringFromFile(string filename, string &str) {
//fjl megnyitsa
    ifstream infile(filename.c_str());
    if (! infile) {
        cerr << "Nincs meg a fajl\n";
        exit(1);
    }

//fjl olvassa
    infile >> str;

//fjl lezrsa
    infile.close();
}

void getArrayFromFileN(string filename, int &N, string arr[MAXN]) {
//fjl megnyitsa
    ifstream infile(filename.c_str());
    if (! infile) {
        cerr << "Nincs meg a fajl\n";
        exit(1);
    }

//fjl olvassa
    N=0;
    string str;
    getline(infile,str);
    N = atoi( str.c_str() );
    if ((N == 0 && str != "0") || (N > MAXN)) {
        cerr << "Hiba! Nem egesz szam vagy nagyobb, mint " << MAXN << ": " << str << endl;
        exit(1);
    }
    int i=0;
    while (i<N) {
        infile >> arr[i];
        i++;
        if (infile.eof()) break;
    }
    if (i<N) {
        cerr << "Figyelmeztetes! Kevesebb elem van. Megadott "<< N << " helyett csak " << i << " erteket sikerult beolvasni." << endl;
        N=i;
    }

//fjl lezrsa
    infile.close();
}

void getArrayFromFile(string filename, int &N, string arr[MAXN]) {
//fjl megnyitsa
    ifstream infile(filename.c_str());
    if (! infile) {
        cerr << "Nincs meg a fajl\n";
        exit(1);
    }

//fjl olvassa
    N=0;
    int i=0;
    while (!infile.eof()) {
        infile >> arr[i];
        i++;
    }
    N=i;

//fjl lezrsa
    infile.close();
}


void getArraysFromFileNM(string filename, int &N, int &M, string arr[MAXN][MAXN]) {
//fjl megnyitsa
    ifstream infile(filename.c_str());
    if (! infile) {
        cerr << "Nincs meg a fajl\n";
        exit(1);
    }

//fjl olvassa
    N=0;
    M=0;
    infile >> N;
    if ((infile.fail()) || (N > MAXN)) {
        cerr << "Hiba! Nem egesz szam vagy nagyobb, mint " << MAXN << ": " << N << endl;
        exit(1);
    }
    string str;
    getline(infile,str);
    M = atoi( str.c_str() );
    if ((M == 0 && str != "0") || (M > MAXN)) {
        cerr << "Hiba! Nem egesz szam vagy nagyobb, mint " << MAXN << ": " << str << endl;
        exit(1);
    }
    int i=0;
    int j=0;
    while (i<N) {
        j=0;
        while (j<M) {
            infile >> arr[i][j];
            j++;
        }
        i++;
        if (infile.eof()) break;
    }
    if (i<N) {
        cerr << "Figyelmeztetes! Kevesebb elem van. Megadott "<< N << " helyett csak " << i << " erteket sikerult beolvasni." << endl;
        N=i;
    }

//fjl lezrsa
    infile.close();
}


void getArraysFromFile(string filename, int &N, int &M, string arr[MAXN][MAXN]) {
//fjl megnyitsa
    ifstream infile(filename.c_str());
    if (! infile) {
        cerr << "Nincs meg a fajl\n";
        exit(1);
    }

//fjl olvassa
    N=0;
    M=0;
    int i=0;
    int j=0;
    string str;
    string s2;
    stringstream ss;
    while (!infile.eof()) {
        getline(infile,str);
        ss << str;
//        cout << ss.str();
        j=0;
        while (1) {
            ss >> arr[i][j];
            if (ss.fail()) break;
            j++;
        }
        ss.clear();
        if (j>M) {
            M=j;
        }
        i++;
    }
    N=i;
/*
    int i=0;
    int j=0;
    while (i<N) {
        j=0;
        while (j<M) {
            infile >> arr[i][j];
            j++;
        }
        i++;
        if (infile.eof()) break;
    }
    if (i<N) {
        cerr << "Figyelmeztetes! Kevesebb elem van. Megadott "<< N << " helyett csak " << i << " erteket sikerult beolvasni." << endl;
        N=i;
    }
*/

//fjl lezrsa
    infile.close();
}



int main()
{

    cout << "FAJLKEZELES" << endl << endl;

//String olvassa
    cout << "getStringFromFile: " <<endl;
    string s;

    getStringFromFile("f_str_in.txt",s);

    cout << s << endl << endl;


//1D Tmb olvassa 1
    cout << "getArrayFromFileN: " << endl;
    int N;
    string tomb[MAXN];

    getArrayFromFileN("f_arrayN_in.txt",N,tomb);

    cout << N << endl;
    for (int i=0;i<N;i++) {
        cout << tomb[i] << "; ";
    }
    cout << endl << endl;

//1D Tmb olvassa 2
    cout << "getArrayFromFile: " << endl;
    int N2;
    string tomb2[MAXN];

    getArrayFromFile("f_array_in.txt",N2,tomb2);

    cout << N2 << endl;
    for (int i=0;i<N2;i++) {
        cout << tomb2[i] << "; ";
    }
    cout << endl << endl;

//2D Tmb olvassa 1
    cout << "getArraysFromFileNM: " << endl;
    int S;
    int O;
    string tomb3[MAXN][MAXN];

    getArraysFromFileNM("f_arraysNM_in.txt",S,O,tomb3);

    cout << S << endl;
    cout << O << endl;
    for (int i=0;i<S;i++) {
        for (int j=0;j<O;j++) {
            cout << tomb3[i][j] << "; ";
        }
        cout << endl;
    }
    cout << endl;


//2D Tmb olvassa 2
    cout << "getArraysFromFile: " << endl;
    int S2;
    int O2;
    string tomb4[MAXN][MAXN];

    getArraysFromFile("f_arrays_in.txt",S2,O2,tomb4);

    cout << S2 << endl;
    cout << O2 << endl;
    for (int i=0;i<S2;i++) {
        for (int j=0;j<O2;j++) {
            cout << tomb4[i][j] << "; ";
        }
        cout << endl;
    }
    cout << endl;

    string vege;
    cout << endl << endl << " --- Vege --- ";
    getline(cin,vege);

    return 0;
}
